# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}
%define native %{?_with_native:1}%{!?_with_native:%{?_without_native:0}%{!?_without_native:%{?_native:%{_native}}%{!?_native:0}}}

Name:          fast-md5
Version:       2.6.1
Release:       2jpp
Epoch:         0
Summary:       Fast MD5 Implementation
URL:           http://www.twmacinta.com/myjava/fast_md5.php
Source0:       %{name}-%{version}.zip
Patch0:        %{name}-%{version}-Makefile.patch
Group:         Development/Libraries
License:       LGPL
Vendor:        JPackage Project
Distribution:  JPackage
%if ! %{gcj_support} && ! %{native}
BuildArch:      noarch
%endif
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: jpackage-utils
BuildRequires: ant
BuildRequires: unzip
%if ! %{gcj_support} && ! %{native}
BuildRequires: make
%endif
%if %{gcj_support}
BuildRequires:    gnu-crypto
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif

 
%description
Fast MD5 is a "fast" implementation of MD5.

%package javadoc
Summary:       Javadoc for %{name}
Group:         Development/Documentation
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description javadoc
%{summary}
 
%package native
Summary:       Native lib for %{name}
Group:         Development/Libraries
Requires:      %{name} = %{epoch}:%{version}-%{release}
 
%description native
%{summary}
 
%prep
%setup -q -n %{name}
%patch0 -p1

%build
ant clean dist

%if %{native} || %{gcj_support}
pushd src
make
popd
%endif
 
%install
rm -rf $RPM_BUILD_ROOT

%if %{native} || %{gcj_support}
install -d -m 755 $RPM_BUILD_ROOT/%{_libdir}
install -m 644 src/lib/arch/linux_%{_arch}/MD5.so $RPM_BUILD_ROOT/%{_libdir}/MD5.so
%endif

%if ! %{native} || %{gcj_support}
install -d -m 755 $RPM_BUILD_ROOT/%{_javadir}
install -d -m 755 $RPM_BUILD_ROOT/%{_javadocdir}/%{name}-%{version}
install -m 644 dist/%{name}.jar $RPM_BUILD_ROOT/%{_javadir}/%{name}-%{version}.jar
pushd $RPM_BUILD_ROOT%{_javadir}
   for jar in *-%{version}.jar ; do
      ln -fs ${jar} $(echo $jar | sed "s|-%{version}.jar|.jar|g")
   done
popd
cp -a dist/docs/javadoc/* $RPM_BUILD_ROOT/%{_javadocdir}/%{name}-%{version}/
ln -s %{name}-%{version} $RPM_BUILD_ROOT/%{_javadocdir}/%{name} # ghost symlink
install -d -m 755 $RPM_BUILD_ROOT/%{_usr}/share/doc/%{name}-%{version}
install -m 644 ChangeLog $RPM_BUILD_ROOT/%{_usr}/share/doc/%{name}-%{version}/
install -m 644 README.txt $RPM_BUILD_ROOT/%{_usr}/share/doc/%{name}-%{version}/
install -m 644 LGPL-v2.1.txt $RPM_BUILD_ROOT/%{_usr}/share/doc/%{name}-%{version}/LICENSE.txt
%endif

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
    rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if ! %{native}
%files
%defattr(-,root,root)
%dir %{_javadir}
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_usr}/share/doc/%{name}-%{version}/README.txt
%{_usr}/share/doc/%{name}-%{version}/LICENSE.txt
%{_usr}/share/doc/%{name}-%{version}/ChangeLog
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%endif

%if %{native} || %{gcj_support}
%files native
%defattr(-,root,root)
%{_libdir}/MD5.so
%endif
 
%changelog
* Thu Apr 19 2007 Ralph Apel <r.apel at r-apel.de> 0:2.6.1-2jpp
- Convert to JPP conventions
- Build bytecode only (noarch) by default
- Add optional separate -native subpackage (--with native)
- Add gcj_support option and include build of -native in this case

* Tue Apr 17 2007 Jesus M. Rodriguez <jesusr@redhat.com> 2.6.1-1
- initial package of fast-md5

